#if !defined(_MAZE_HPP_)
#define _MAZE_HPP_

#include <ISAOLED.h>
#include <ISADefinitions.h>
#include <ISALiquidCrystal.h>
#include <ISA7SegmentDisplay.h>


#define SQUARE_SIZE 4
#define BOARD_HEIGHT 16
#define BOARD_WIDTH 32

class Maze {
  private:
    bool board[BOARD_HEIGHT][BOARD_WIDTH];

    int startx, starty;
    int stopx, stopy;
    int playerx, playery;

    ISAOLED oled;
    ISALiquidCrystal lcd;
    ISA7SegmentDisplay ss;    
  
  public:
    Maze(void);

  private:
    void Init(void);
    void ShowBoard(void);
    void DrawSquare(int,int,bool);
    bool Step(int dx, int dy);
    
  public:
    void GoUp(void);
    void GoDown(void);
    void GoLeft(void);
    void GoRight(void);
};



#endif // _MAZE_HPP_
