#define BLOCK_SIZE 4
#define WIDTH 128
#define HEIGHT 64

enum Direction
{
  LEFT, 
  RIGHT,
  DOWN,
  UP
};

class Snake
{

  public:

    void init() 
    {
        sseg.init();
        oled.begin();
        lcd.begin();
        pinMode(KEY_UP, INPUT);
        pinMode(KEY_DOWN, INPUT);
        pinMode(KEY_LEFT, INPUT);
        pinMode(KEY_RIGHT, INPUT);
        pinMode(BUZZER, OUTPUT);
        for (int i = 0; i < 8; ++i)
          pinMode(LEDS[i], OUTPUT);
        restart();
        lcd.print("KMT AMU 2019");
        lcd.setCursor(0, 1);
        lcd.print("SNAKE");
    }
    void change_direction(enum Direction d) { dir = d; }

    void display_points()
    {
      sseg.displayDigit(points % 10, 0);
      sseg.displayDigit((points / 10) % 10, 1);
      
    }
    
    void draw_food()
    {
      while (1)
      {
        int found = 1;
        food.first = random(32) * 4;
        food.second = random(16) * 4;

        for (int i = 0; i < size; ++i)
          if (snake[i].first == food.first && snake[i].second == food.second)
            found = 0;
          
        if (found)
          break;
      }
    }

    void restart()
    {
        size = 1;
        points = 0;
        snake[0] = std::pair<int, int>(4, 4);
        dir = UP;
        draw_food();
        speed = 0;
    }
    
    void move_snake()
    {
      std::pair<int, int> new_head = snake[0];
      switch(dir)
      {
        case LEFT:
          new_head.first = (new_head.first - BLOCK_SIZE + WIDTH) % WIDTH;
          break;
        case RIGHT:
          new_head.first = (new_head.first + BLOCK_SIZE) % WIDTH;
          break;
        case UP:
          new_head.second = (new_head.second - BLOCK_SIZE + HEIGHT) % HEIGHT;
          break;
        case DOWN:
          new_head.second = (new_head.second + BLOCK_SIZE) % HEIGHT;
          break;
        default:
          return;
      }
      for (int i = size; i > 0; --i)
        snake[i] = snake[i - 1];
      snake[0] = new_head;
//      --size;
    }

    int eat()
    {
      size++;
      points++;
    }
  
    bool check_uroboros_state()
    {
      for (int i = 1; i < size; ++i)
        if (snake[0].first == snake[i].first && snake[i].second == snake[0].second)
          return true;

      return false;
    }
  
    void display()
    {
  //    oled.wri?teRect(5, 5, BLOCK_SIZE, BLOCK_SIZE, true);
  
//      Serial.print(snake[0].second);
      oled.clear(false);
      
      for (int i = 0; i < size; ++i)
        oled.writeRect(snake[i].first, snake[i].second, BLOCK_SIZE, BLOCK_SIZE, true);
      oled.writeRect(food.first, food.second, BLOCK_SIZE, BLOCK_SIZE, false);
  
      oled.renderAll();    
    }
  
    std::pair<int, int> get_head_position() {return snake[0];}
    std::pair<int, int> get_food_position() {return food;}

    int get_points() { return points; }
    int get_speed() { return 200 - 20 * speed; }
  
    void change_speed(int new_speed)
    {
      speed = new_speed >= 0 ? (new_speed <= 8 ? new_speed : 8) : 0; 
    }
    
  private:
    enum Direction dir;
    std::pair<int, int> snake[100];
    int size;
    std::pair<int, int> food;
    ISAOLED oled;
    int points;
    ISA7SegmentDisplay sseg;
    int speed;
    ISALiquidCrystal lcd;
};
